Index: /trunk/src/sh_suidchk.c
===================================================================
--- /trunk/src/sh_suidchk.c	(revision 584)
+++ /trunk/src/sh_suidchk.c	(revision 1)
@@ -30,5 +30,7 @@
 #include <errno.h>
 #include <limits.h>
-
+#ifdef HAVE_LIBGEN_H
+#include <libgen.h>
+#endif
 #ifdef HAVE_SCHED_H
 #include <sched.h>
@@ -37,4 +39,8 @@
 #ifdef SH_USE_SUIDCHK
 
+#ifndef HAVE_BASENAME
+#define basename(a) ((NULL == strrchr(a, '/')) ? (a) : (strrchr(a, '/')))
+#endif
+
 #undef  FIL__
 #define FIL__  _("sh_suidchk.c")
@@ -42,8 +48,14 @@
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE) 
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
 
 #ifdef HAVE_DIRENT_H
@@ -63,8 +75,6 @@
 #endif
 #endif
-#define NEED_ADD_DIRENT
 
 #include "samhain.h"
-#include "sh_pthread.h"
 #include "sh_utils.h"
 #include "sh_error.h"
@@ -72,10 +82,8 @@
 #include "sh_suidchk.h"
 #include "sh_hash.h"
-#include "sh_dbIO.h"
 #include "sh_unix.h"
 #include "sh_files.h"
 #include "sh_schedule.h"
 #include "sh_calls.h"
-#include "zAVLTree.h"
 
 
@@ -110,8 +118,4 @@
   },
   {
-    N_("suidchecknosuid"),
-    sh_suidchk_set_nosuid
-  },
-  {
     N_("suidcheckquarantinefiles"),
     sh_suidchk_set_quarantine
@@ -135,6 +139,5 @@
 static int     ShSuidchkActive   = S_TRUE;
 static time_t  ShSuidchkInterval = 7200;
-static unsigned long    ShSuidchkFps      = 0;
-static int     ShSuidchkNosuid   = S_FALSE;
+static long    ShSuidchkFps      = 0;
 static int     ShSuidchkYield    = S_FALSE;
 static int     ShSuidchkQEnable  = S_FALSE;
@@ -142,36 +145,13 @@
 static int     ShSuidchkQDelete  = S_FALSE;
 static int     ShSuidchkSeverity = SH_ERR_SEVERE;
+static char *  ShSuidchkExclude  = NULL;
+static int     ExcludeLen        = 0;
 
 static time_t  FileLimNow        = 0;
 static time_t  FileLimStart      = 0;
-static unsigned long    FileLimNum        = 0;
-static unsigned long    FileLimTotal      = 0;
+static long    FileLimNum        = 0;
+static long    FileLimTotal      = 0;
 
 static sh_schedule_t * ShSuidchkSched = NULL;
-
-
-static zAVLTree *  ShSuidchkExclude  = NULL;
-static void sh_suid_exclude_free()
-{
-  zAVL_string_reset(ShSuidchkExclude);
-  ShSuidchkExclude  = NULL;
-  return;
-}
-static int sh_suid_exclude_add(const char * str)
-{
-  size_t len;
-  int    ret;
-  char * key = sh_util_strdup(str);
-
-  len = sl_strlen (key);
-  if (len && key[len-1] == '/')
-    {
-      key[len-1] = '\0';
-    }
-  ret = zAVL_string_set(&ShSuidchkExclude, key);
-  SH_FREE(key);
-  return ret;
-}
-
 
 static char *
@@ -182,35 +162,8 @@
 #endif
 
-SH_MUTEX_STATIC(mutex_suid_check, PTHREAD_MUTEX_INITIALIZER);
-
 extern unsigned long sh_files_maskof (int class);
-
-static void set_defaults (void)
-{
-  ShSuidchkActive   = S_TRUE;
-  ShSuidchkInterval = 7200;
-  ShSuidchkFps      = 0;
-  ShSuidchkNosuid   = S_FALSE;
-  ShSuidchkYield    = S_FALSE;
-  ShSuidchkQEnable  = S_FALSE;
-  ShSuidchkQMethod  = SH_Q_CHANGEPERM;
-  ShSuidchkQDelete  = S_FALSE;
-  ShSuidchkSeverity = SH_ERR_SEVERE;
-  if (ShSuidchkExclude != NULL)
-    sh_suid_exclude_free();
-
-  FileLimNow        = 0;
-  FileLimStart      = 0;
-  FileLimNum        = 0;
-  FileLimTotal      = 0;
-
-  return;
-}
 
 /* Recursively descend into the directory to make sure that
  * there is no symlink in the path.
- *
- * Use retry_lstat_ns() here because we cannot chdir the subprocess
- * that does the lstat().
  */
 static int do_truncate_int (char * path, int depth)
@@ -220,13 +173,10 @@
   struct stat two;
   int         fd;
-  char errbuf[SH_ERRBUF_SIZE];
 
   if (depth > 99)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 		       MSG_SUID_ERROR,
 		       _("do_truncate: max depth 99 exceeded"));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       return -1;
     }
@@ -234,9 +184,7 @@
   if (path[0] != '/')
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 		       MSG_SUID_ERROR,
 		       _("do_truncate: not an absolute path"));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       return -1;
     }
@@ -246,11 +194,9 @@
     {
       *q = '\0';
-      if (0 != retry_lstat_ns(FIL__, __LINE__, path, &one))
+      if (0 != retry_lstat(FIL__, __LINE__, path, &one))
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message(errno));
 	  *q = '/'; 
 	  return -1; 
@@ -259,9 +205,7 @@
 	
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 			   MSG_SUID_ERROR,
 			   _("Possible race: not a directory"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  *q = '/'; 
 	  return -1; 
@@ -271,20 +215,16 @@
       if (0 != chdir(path))
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message(errno));
 	  *q = '/';
 	  return -1;
 	}
       *q = '/';
-      if (0 != retry_lstat_ns(FIL__, __LINE__, ".", &two))
+      if (0 != retry_lstat(FIL__, __LINE__, ".", &two))
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message(errno));
 	  return -1; 
 	}
@@ -293,9 +233,7 @@
 	  (!S_ISDIR(two.st_mode))/*@+usedef@*/)
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 			   MSG_SUID_ERROR,
 			   _("Possible race: lstat(dir) != lstat(.)"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  return -1;
 	}
@@ -310,11 +248,9 @@
       if (*path == '\0')
 	return -1;
-      if (0 != retry_lstat_ns(FIL__, __LINE__, path, &one))
+      if (0 != retry_lstat(FIL__, __LINE__, path, &one))
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message(errno));
 	  return -1;
 	} 
@@ -322,19 +258,15 @@
       if (-1 == fd)
 	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message(errno));
 	  return -1;
 	} 
       if (0 != retry_fstat(FIL__, __LINE__, fd, &two))
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
-			   sh_error_message(errno, errbuf, sizeof(errbuf)));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  (void) sl_close_fd(FIL__, __LINE__, fd);
+			   sh_error_message(errno));
+	  (void) close(fd);
 	  return -1; 
 	}
@@ -342,30 +274,24 @@
 	  (one.st_ino != two.st_ino)/*@+usedef@*/)
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 			   MSG_SUID_ERROR,
 			   _("Possible race: lstat != fstat"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  (void) sl_close_fd(FIL__, __LINE__, fd); 
+	  (void) close(fd); 
 	  return -1;
 	}
       if (!S_ISREG(two.st_mode))
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 			   MSG_SUID_ERROR,
 			   _("Possible race: not a regular file"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  (void) sl_close_fd(FIL__, __LINE__, fd); 
+	  (void) close(fd); 
 	  return -1;
 	}
       if ((0 == (two.st_mode & S_ISUID)) && (0 == (two.st_mode & S_ISGID)))
 	{ 
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 			   MSG_SUID_ERROR,
 			   _("Possible race: not a suid/sgid file"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  (void) sl_close_fd(FIL__, __LINE__, fd); 
+	  (void) close(fd); 
 	  return -1;
 	}
@@ -379,29 +305,23 @@
 	  if (-1 == /*@-unrecog@*/fchmod(fd, two.st_mode)/*@+unrecog@*/)
 	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
 	      sh_error_handle ((-1), FIL__, __LINE__, errno,
 			       MSG_SUID_ERROR,
-			       sh_error_message(errno, errbuf, sizeof(errbuf)));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      (void) sl_close_fd(FIL__, __LINE__, fd); 
+			       sh_error_message(errno));
+	      (void) close(fd); 
 	      return -1;
 	    }
 #else
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, errno,
 			   MSG_SUID_ERROR,
 			   _("The fchmod() function is not available"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  (void) sl_close_fd(FIL__, __LINE__, fd); 
+	  (void) close(fd); 
 	  return -1;
 #endif
 	  if (two.st_nlink > 1)
 	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
 	      sh_error_handle ((-1), FIL__, __LINE__, 0,
 			       MSG_SUID_ERROR,
 			       _("Not truncated because hardlink count gt 1"));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      (void) sl_close_fd(FIL__, __LINE__, fd); 
+	      (void) close(fd); 
 	      return -1;
 	    }
@@ -410,10 +330,8 @@
 	  if (-1 == /*@-unrecog@*/ftruncate(fd, 0)/*@+unrecog@*/)
 	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
 	      sh_error_handle ((-1), FIL__, __LINE__, errno,
 			       MSG_SUID_ERROR,
-			       sh_error_message(errno, errbuf, sizeof(errbuf)));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      (void) sl_close_fd(FIL__, __LINE__, fd); 
+			       sh_error_message(errno));
+	      (void) close(fd); 
 	      return -1;
 	    }
@@ -423,605 +341,83 @@
 	  if (-1 == retry_aud_unlink(FIL__, __LINE__, path))
 	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
 	      sh_error_handle ((-1), FIL__, __LINE__, errno,
 			       MSG_SUID_ERROR,
-			       sh_error_message(errno, errbuf, sizeof(errbuf)));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      (void) sl_close_fd(FIL__, __LINE__, fd); 
+			       sh_error_message(errno));
+	      (void) close(fd); 
 	      return -1;
 	    }
 	}
-      (void) sl_close_fd (FIL__, __LINE__, fd);
+      (void) close (fd);
       return (0);
     }
 }
 
-static int do_truncate (const char * path_in)
-{
-  volatile int    caperr;
-  int    result;
-  char * path;
-  char errbuf[SH_ERRBUF_SIZE];
+static int do_truncate (char * path)
+{
+  int         caperr;
+  int result;
 
   if (0 != chdir("/"))
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, errno,
 		       MSG_SUID_ERROR,
-		       sh_error_message(errno, errbuf, sizeof(errbuf)));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
+		       sh_error_message(errno));
     }
 
   if (0 != (caperr = sl_get_cap_qdel()))
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-		      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+		      sh_error_message (caperr), 
 		      _("sl_get_cap_qdel"));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-    }
-
-  path   = sh_util_strdup  (path_in);
+    }
+
   result = do_truncate_int (path, 0);
-  SH_FREE(path);
 
   if (0 != (caperr = sl_drop_cap_qdel()))
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-		      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+		      sh_error_message (caperr), 
 		      _("sl_drop_cap_qdel"));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
     }
 
   if (0 != chdir("/"))
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, errno,
 		       MSG_SUID_ERROR,
-		       sh_error_message(errno, errbuf, sizeof(errbuf)));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
+		       sh_error_message(errno));
     }
   return result;
 }
-
-/* This variable is not used anywhere. It only exists
- * to assign &dirlist to it, which keeps gcc from
- * putting it into a register, and avoids the 'clobbered
- * by longjmp' warning. And no, 'volatile' proved insufficient.
- */
-static void * sh_dummy_tmp = NULL;
-
-static void sh_q_delete(const char * fullpath)
-{
-  int    status;
-  char * msg;
-  char * tmp;
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_tmp = (void*) &tmp;
-
-  if (do_truncate (fullpath) == -1)
-    {
-      status = errno;
-      msg    = SH_ALLOC(SH_BUFSIZE);
-      tmp    = sh_util_safe_name(fullpath);
-
-      (void) sl_snprintf(msg, SH_BUFSIZE, 
-			 _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), 
-			 status);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle (ShSuidchkSeverity,
-		       FIL__, __LINE__, 
-		       status,
-		       MSG_SUID_QREPORT, msg,
-		       tmp );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(tmp);
-      SH_FREE(msg);
-    }
-  else
-    {
-      tmp    = sh_util_safe_name(fullpath);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle (ShSuidchkSeverity,
-		       FIL__, __LINE__, 0,
-		       MSG_SUID_QREPORT,
-		       _("Quarantine method applied"),
-		       tmp );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(tmp);
-    }
-  return;
-}
-
-/* This variable is not used anywhere. It only exists
- * to assign &dirlist to it, which keeps gcc from
- * putting it into a register, and avoids the 'clobbered
- * by longjmp' warning. And no, 'volatile' proved insufficient.
- */
-static void * sh_dummy_mtmp = NULL;
-static void * sh_dummy_mmsg = NULL;
-
-static void sh_q_move(const char * fullpath, file_type * theFile, 
-		      const char * timestrc, const char * timestra, 
-		      const char * timestrm)
-{
-  volatile int  status;
-  int           readFile  = -1;
-  volatile int  writeFile = -1;
-  struct stat   fileInfo;
-  ssize_t       count;
-  char        * msg;
-  char        * tmp;
-  char        * basetmp;
-  char        * filetmp;
-  char          buffer[1024];
-  char        * dir = SH_ALLOC(PATH_MAX+1);
-  mode_t        umask_old;
-  FILE *        filePtr = NULL;
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_mtmp = (void*) &tmp;
-  sh_dummy_mmsg = (void*) &msg;
-
-  (void) sl_strlcpy (dir, DEFAULT_QDIR, PATH_MAX+1);
-
-  if (retry_stat (FIL__, __LINE__, dir, &fileInfo) != 0)
-    {
-      /* Quarantine directory does not exist,
-       */
-      status = errno;
-      msg    = SH_ALLOC(SH_BUFSIZE);
-      tmp    = sh_util_safe_name(fullpath);
-
-      (void) sl_snprintf(msg, SH_BUFSIZE, 
-			 _("Problem quarantining file.  File NOT quarantined.  errno = %ld (stat)"), 
-			 status);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle (ShSuidchkSeverity,
-		       FIL__, __LINE__, 
-		       status,
-		       MSG_SUID_QREPORT, msg,
-		       tmp );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(tmp);
-      SH_FREE(msg);
-    }
-  else
-    {
-      if (retry_lstat (FIL__, __LINE__, 
-		       fullpath, &fileInfo) == -1)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld(stat)"), status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT,
-			   msg, tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	}
-      else
-	{
-	  basetmp = sh_util_strdup(fullpath);
-	  filetmp = SH_ALLOC(PATH_MAX+1);
-	  tmp     = sh_util_basename(basetmp);
-
-	  (void) sl_snprintf(filetmp, PATH_MAX+1, "%s/%s", 
-			     DEFAULT_QDIR, tmp);
-	  SH_FREE(tmp);
-	  SH_FREE(basetmp);
-	  
-	  readFile  = open (fullpath, O_RDONLY);
-	  if (readFile != -1)
-	    writeFile = open (filetmp, O_WRONLY|O_CREAT, S_IRUSR|S_IWUSR|S_IXUSR);
-	  
-	  if ((readFile == -1) || (writeFile == -1))
-	    {
-	      status = errno;
-	      msg    = SH_ALLOC(SH_BUFSIZE);
-	      tmp    = sh_util_safe_name(fullpath);
-
-	      (void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld (open)"), status);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (ShSuidchkSeverity,
-			       FIL__, __LINE__, status,
-			       MSG_SUID_QREPORT,
-			       msg, tmp );
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      SH_FREE(tmp);
-	      SH_FREE(msg);
-	    }
-	  else
-	    { 
-	      /* sizeof(buffer) is 1024 
-	       */
-	      while ((count = (int) read (readFile, buffer, sizeof (buffer))) > 0)
-		{
-		  if ((int) write (writeFile, buffer, (size_t) count) != count)
-		    {
-		      status = errno;
-		      msg    = SH_ALLOC(SH_BUFSIZE);
-		      tmp    = sh_util_safe_name(fullpath);
-
-		      (void) sl_snprintf(msg, SH_BUFSIZE, 
-					 _("I/O error.  errno = %ld (write)"), status);
-		      SH_MUTEX_LOCK(mutex_thread_nolog);
-		      sh_error_handle (ShSuidchkSeverity,
-				       FIL__,
-				       __LINE__,
-				       status,
-				       MSG_SUID_QREPORT,
-				       msg, tmp );
-		      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		      SH_FREE(tmp);
-		      SH_FREE(msg);
-		    }
-		}
-	    }
-
-	  (void) sl_close_fd (FIL__, __LINE__, readFile);
-	  (void) fchmod(writeFile, S_IRUSR | S_IWUSR | S_IXUSR);
-	  (void) sl_close_fd (FIL__, __LINE__, writeFile);
-
-	  if (do_truncate (fullpath) == -1)
-	    {
-	      status = errno;
-	      msg    = SH_ALLOC(SH_BUFSIZE);
-	      tmp    = sh_util_safe_name(fullpath);
-
-	      (void) sl_snprintf(msg, SH_BUFSIZE, 
-				 _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), 
-				 status);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (ShSuidchkSeverity,
-			       FIL__, __LINE__, status,
-			       MSG_SUID_QREPORT,
-			       msg, tmp );
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      SH_FREE(tmp);
-	      SH_FREE(msg);
-	    }
-	  else
-	    {
-	      tmp = sh_util_basename(fullpath);
-
-	      (void) sl_snprintf(filetmp, PATH_MAX+1, "%s/%s.info", 
-				 DEFAULT_QDIR, 
-				 tmp);
-
-	      SH_FREE(tmp);
-	      /*
-	       * avoid chmod by setting umask
-	       */
-	      umask_old = umask (0077);
-	      filePtr   = fopen (filetmp, "w+");
-
-	      /*@-usedef@*/
-	      if (filePtr)
-		{
-		  fprintf(filePtr, 
-			  _("File Info:\n filename=%s\n size=%lu\n owner=%s(%d)\n group=%s(%d)\n ctime=%s\n atime=%s\n mtime=%s\n"), 
-			  fullpath, 
-			  (unsigned long) theFile->size, 
-			  theFile->c_owner, (int) theFile->owner, 
-			  theFile->c_group, (int) theFile->group, 
-			  timestrc, timestra, timestrm);
-		  (void) sl_fclose (FIL__, __LINE__, filePtr);
-		}
-	      /*@+usedef@*/
-	      umask (umask_old);
-	      
-	      tmp    = sh_util_safe_name(fullpath);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (ShSuidchkSeverity,
-			       FIL__,__LINE__,
-			       0, MSG_SUID_QREPORT,
-			       _("Quarantine method applied"),
-			       tmp );
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      SH_FREE(tmp);
-	    }
-	  SH_FREE(filetmp);
-	}
-    }
-  SH_FREE(dir);
-  return;
-}
-
-/* This variable is not used anywhere. It only exists
- * to assign &dirlist to it, which keeps gcc from
- * putting it into a register, and avoids the 'clobbered
- * by longjmp' warning. And no, 'volatile' proved insufficient.
- */
-static void * sh_dummy_ctmp = NULL;
-static void * sh_dummy_cmsg = NULL;
-
-static void sh_q_changeperm(const char * fullpath)
-{
-  volatile int    caperr;
-  volatile int    status;
-  char          * msg;
-  char          * tmp;
-  struct stat     fileInfo;
-  struct stat     fileInfo_F;
-  int             cperm_status = 0;
-  volatile int    file_d       = -1;
-  char errbuf[SH_ERRBUF_SIZE];
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_ctmp = (void*) &tmp;
-  sh_dummy_cmsg = (void*) &msg;
-
-  if (retry_lstat(FIL__, __LINE__, fullpath, &fileInfo) == -1)
-    {
-      status = errno;
-      msg    = SH_ALLOC(SH_BUFSIZE);
-      tmp    = sh_util_safe_name(fullpath);
-
-      (void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld"), status);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle (ShSuidchkSeverity,
-		       FIL__, __LINE__, 
-		       status,
-		       MSG_SUID_QREPORT, msg,
-		       tmp );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(tmp);
-      SH_FREE(msg);
-      cperm_status = -1;
-    }
-  
-  if (cperm_status == 0)
-    {
-      if (0 != (caperr = sl_get_cap_qdel()))
-	{
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle((-1), FIL__, __LINE__, 
-			  caperr, MSG_E_SUBGEN,
-			  sh_error_message (caperr, errbuf, sizeof(errbuf)), 
-			  _("sl_get_cap_qdel"));
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  cperm_status = -1;
-	}
-    }
-  
-  if (cperm_status == 0)
-    {
-      file_d = aud_open (FIL__, __LINE__, SL_YESPRIV,
-			 fullpath, O_RDONLY, 0);
-      if (-1 == file_d)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld"), status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT, msg,
-			   tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	  cperm_status = -1;
-	}
-    }
-  
-  if (cperm_status == 0)
-    {
-      if (retry_fstat(FIL__, __LINE__, file_d, &fileInfo_F) == -1)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, 
-			     _("I/O error.  errno = %ld"), status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT, msg,
-			   tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	  cperm_status = -1;
-	}
-    }
-  
-  if (cperm_status == 0)
-    {
-      if (fileInfo_F.st_ino  != fileInfo.st_ino ||
-	  fileInfo_F.st_dev  != fileInfo.st_dev ||
-	  fileInfo_F.st_mode != fileInfo.st_mode)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, 
-			     _("Race detected.  errno = %ld"), status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT, msg,
-			   tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	  cperm_status = -1;
-	}
-    }
-  
-  if ((fileInfo.st_mode & S_ISUID) > 0)
-    fileInfo.st_mode -= S_ISUID;
-  if ((fileInfo.st_mode & S_ISGID) > 0)
-    fileInfo.st_mode -= S_ISGID;
-  
-  if (cperm_status == 0)
-    {
-      if (fchmod(file_d, fileInfo.st_mode) == -1)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, 
-			     _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), 
-			     status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT,
-			   msg, tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	}
-      else
-	{
-	  tmp    = sh_util_safe_name(fullpath);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   0,
-			   MSG_SUID_QREPORT,
-			   _("Quarantine method applied"),
-			   tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	}
-    }
-  
-  if (0 != (caperr = sl_drop_cap_qdel()))
-    {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle((-1), FIL__, __LINE__, 
-		      caperr, MSG_E_SUBGEN,
-		      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
-		      _("sl_drop_cap_qdel"));
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-    }
-  
-  if (file_d != -1)
-    {
-      do {
-	status = sl_close_fd (FIL__, __LINE__, file_d);
-      } while (status == -1 && errno == EINTR);
-      
-      if (-1 == status)
-	{
-	  status = errno;
-	  msg    = SH_ALLOC(SH_BUFSIZE);
-	  tmp    = sh_util_safe_name(fullpath);
-
-	  (void) sl_snprintf(msg, SH_BUFSIZE, 
-			     _("I/O error.  errno = %ld"), status);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle (ShSuidchkSeverity,
-			   FIL__, __LINE__, 
-			   status,
-			   MSG_SUID_QREPORT, msg,
-			   tmp );
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp);
-	  SH_FREE(msg);
-	}
-    }
-  return;
-}
-
-static void report_file (const char * tmpcat, file_type * theFile, 
-			 char * timestrc, char * timestra, char * timestrm)
-{
-  char * msg = SH_ALLOC(SH_BUFSIZE);
-  char * tmp = sh_util_safe_name(tmpcat);
-
-  msg[0] = '\0';
-  /*@-usedef@*/
-
-#ifdef SH_USE_XML
-  (void) sl_snprintf(msg, SH_BUFSIZE, _("owner_new=\"%s\" iowner_new=\"%ld\" group_new=\"%s\" igroup_new=\"%ld\" size_new=\"%lu\" ctime_new=\"%s\" atime_new=\"%s\" mtime_new=\"%s\""), 
-		     theFile->c_owner, theFile->owner, 
-		     theFile->c_group, theFile->group, 
-		     (unsigned long) theFile->size, 
-		     timestrc, timestra, timestrm);
-#else
-  (void) sl_snprintf(msg, SH_BUFSIZE, _("owner_new=<%s>, iowner_new=<%ld>, group_new=<%s>, igroup_new=<%ld>, filesize=<%lu>, ctime=<%s>, atime=<%s>, mtime=<%s>"), 
-		     theFile->c_owner, theFile->owner, 
-		     theFile->c_group, theFile->group, 
-		     (unsigned long) theFile->size, 
-		     timestrc, timestra, timestrm);
-#endif
-  /*@+usedef@*/
-  
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  sh_error_handle (ShSuidchkSeverity, FIL__, __LINE__, 
-		   0, MSG_SUID_POLICY,
-		   _("suid/sgid file not in database"),
-		   tmp, msg );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-  SH_FREE(tmp);
-  SH_FREE(msg);
-  return;
-}
-
-/* This variable is not used anywhere. It only exists
- * to assign &dirlist to it, which keeps gcc from
- * putting it into a register, and avoids the 'clobbered
- * by longjmp' warning. And no, 'volatile' proved insufficient.
- */
-void * sh_dummy_idirlist = NULL;
-void * sh_dummy_itmp     = NULL;
-
 
 static
 int sh_suidchk_check_internal (char * iname)
 {
+  int             caperr;
   DIR *           thisDir = NULL;
+  FILE *          filePtr = NULL;
   struct dirent * thisEntry;
   char          * tmpcat;
   char          * tmp;
+  char          * msg;
+  char          * dir;
+  char          * filetmp;
+  char          * basetmp;
   char            timestrc[32];
   char            timestra[32];
   char            timestrm[32];
+  char            buffer[1024];
   struct stat     buf;
-  volatile int    status;
-  int             fflags;
+  int             status;
+  int             count;
+  int             readFile = -1;
+  int             writeFile = -1;
   char          * fs;
-  volatile long   sl_status;
-  file_type     * theFile = NULL;
-  char            fileHash[2*(KEY_LEN + 1)];
-
-  struct sh_dirent * dirlist;
-  struct sh_dirent * dirlist_orig;
-  char errbuf[SH_ERRBUF_SIZE];
+  long            sl_status = SL_ENONE;
+  struct stat     fileInfo;
+
+  file_type       theFile;
+  char            fileHash[KEY_LEN + 1];
 
   SL_ENTER(_("sh_suidchk_check_internal"));
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_idirlist = (void*) &dirlist;
-  sh_dummy_itmp     = (void*) &tmp;
 
   if (iname == NULL)
@@ -1041,21 +437,17 @@
       status = errno;
       tmp = sh_util_safe_name(iname);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle (ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__, status, 
 		       MSG_E_OPENDIR,
-		       sh_error_message (status, errbuf, sizeof(errbuf)), tmp);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
+		       sh_error_message (status), tmp);
       SH_FREE(tmp);
       SL_RETURN( (-1), _("sh_suidchk_check_internal"));
     }
 
-  /* Loop over directory entries
-   */
-  SH_MUTEX_LOCK(mutex_readdir);
-
-  dirlist      = NULL;
-  dirlist_orig = NULL;
-
   do {
+
+    if (sig_urgent > 0) {
+      SL_RETURN( (0), _("sh_suidchk_check_internal"));
+    }
+
 
     thisEntry = readdir (thisDir);
